'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _XEditable = require('./XEditable');

var _XEditable2 = _interopRequireDefault(_XEditable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EditableSelect = function (_React$Component) {
  (0, _inherits3.default)(EditableSelect, _React$Component);

  function EditableSelect(props) {
    (0, _classCallCheck3.default)(this, EditableSelect);

    var _this = (0, _possibleConstructorReturn3.default)(this, (EditableSelect.__proto__ || (0, _getPrototypeOf2.default)(EditableSelect)).call(this, props));

    _initialiseProps.call(_this);

    _this.setState = _this.setState.bind(_this);

    var options = _this.convertOptions(_this.props.options);
    if (_this.props.defaultOptionText) {
      options.unshift({ text: _this.props.defaultOptionText, value: null });
    }
    var selected = options.find(function (opt) {
      if (opt.value === _this.props.value) {
        return opt;
      }
    });

    var text = 'Invalid value';

    if (selected) {
      text = selected.text;
    } else if (_this.props.defaultOptionText) {
      text = _this.props.defaultOptionText;
    }
    _this.state = {
      isEditing: false,
      options: options,
      text: text,
      value: _this.props.value
    };

    return _this;
  }

  (0, _createClass3.default)(EditableSelect, [{
    key: 'render',
    value: function render() {
      if (this.state.isEditing) {
        var options = this.state.options.map(function (opt, index) {
          return _react2.default.createElement(
            'option',
            { key: index, value: opt.value },
            opt.text
          );
        });
        return _react2.default.createElement(
          _XEditable2.default,
          { isLoading: false, save: this.save, cancel: this.cancel },
          _react2.default.createElement(
            'select',
            { ref: 'el', className: 'form-control input-sm', name: this.props.name, defaultValue: this.state.value },
            options
          )
        );
      } else {
        return _react2.default.createElement(
          'a',
          { href: 'javascript:;', className: 'editable editable-click', onClick: this.handleLinkClick },
          this.state.text
        );
      }
    }
  }]);
  return EditableSelect;
}(_react2.default.Component);

EditableSelect.defaultProps = {
  name: null
};
EditableSelect.propTypes = {
  name: _react2.default.PropTypes.string.isRequired,
  onUpdate: _react2.default.PropTypes.func.isRequired,
  options: _react2.default.PropTypes.array.isRequired,
  defaultOptionText: _react2.default.PropTypes.string
};

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.save = function (event) {
    event.preventDefault();
    _this2.props.onUpdate(_this2.props.name, _this2.refs.el.value);
    _this2.setState({
      isEditing: false,
      text: _this2.refs.el.options[_this2.refs.el.selectedIndex].text,
      value: _this2.refs.el.value
    });
  };

  this.cancel = function () {
    _this2.setState({ isEditing: false });
  };

  this.handleLinkClick = function () {
    _this2.setState({ isEditing: true });
  };

  this.convertOptions = function (options) {
    return options.map(function (opt) {
      if (typeof opt === 'string' || typeof opt === 'number' || typeof opt === 'boolean') {
        return { text: opt, value: opt };
      }
      return { text: opt.text, value: opt.value };
    });
  };
};

exports.default = EditableSelect;
module.exports = exports['default'];